import { ComponentClass, ComponentType } from 'react';
import { Observable, SchedulerLike } from 'rxjs';
import { Omit } from 'typelevel-ts';
export declare type Observify<P extends object> = {
    readonly [K in keyof P]: Observable<P[K]>;
};
export declare type WithRXSelectorResult<P extends object> = {
    props?: Partial<Observify<P>>;
    effects$?: Observable<unknown>;
};
export declare type WithRXOptions = {
    scheduler?: SchedulerLike;
};
export declare function withRX<P extends object, D extends Partial<P>>(Target: ComponentType<P>, defaultProps: D, selector: (props$: Observable<Readonly<P>>) => WithRXSelectorResult<P>, options?: WithRXOptions): ComponentClass<Omit<P, keyof D> & Partial<D>>;
